/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <syslog.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <arpa/inet.h>
#include <termio.h>
#define XtNumber(x) sizeof(x)/sizeof(x[0])

#include "struct.h"

void *fifo( void *a ) {

	workp works =(workp)a;
	int rc;
	char buf[100];
	char c;
	int j;
	struct termios TtyAttr;
	int ByteBits = CS8;

	works->outfifo=-1;

	syslog( LOG_INFO, "Fifo thread started" );
	prctl( PR_SET_NAME, (unsigned long)"Fifo", 0, 0, 0 );

	((workp)works)->fifoFd = open( ((workp)works)->setup->FifoDevice, O_RDWR | O_NOCTTY );
	if( ((workp)works)->fifoFd == -1 ) {
		syslog( LOG_ERR, "unable to open fifo device %s, error %d", ((workp)works)->setup->FifoDevice, errno );
	}
	memset( &TtyAttr, 0, sizeof( struct termios ) );
	TtyAttr.c_iflag = IGNPAR;
	TtyAttr.c_cflag = ByteBits | CREAD | CLOCAL;
	TtyAttr.c_cc[VMIN] = 1;
	tcflush( ((workp)works)->fifoFd, TCIFLUSH );
	cfsetispeed( &TtyAttr, ((workp)works)->setup->FifoBaud );
	cfsetospeed( &TtyAttr, ((workp)works)->setup->FifoBaud );
	if( tcsetattr( ((workp)works)->fifoFd, TCSANOW, &TtyAttr ) < 0 ) {
		syslog( LOG_ERR, "Unable to set comm port %s", ((workp)works)->setup->FifoDevice );
	}

	j=0;
	// continuous loop
	for( ; works->unterminated; ) {		
		for( ;; ) {
			rc=read( works->fifoFd, &c, 1 );
			if( rc == 1 ) {
				break;
			}
			usleep( 10000 );
		}
		buf[j++]=c;
		if( j>=sizeof( buf ) ) {
			memset( buf, 0, sizeof( buf ) );
			j=0;
			syslog( LOG_ERR, "CAT fifo buffer size exceeded" );
			continue;
		}
		if( c==';' ) {
			buf[j]=0;
			sendWebSockCatFrame( works, buf, strlen(buf) );
			j=0;
		}
	}
	
	close( works->fifoFd );
	syslog( LOG_INFO, "Fifo operations end\n" );
	pthread_exit( a );
	return( a );
}

