/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <syslog.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <arpa/inet.h>
#define XtNumber(x) sizeof(x)/sizeof(x[0])

#include "struct.h"

void gotx( workp works, int dot ) {
	struct timeval tv;
	char buffer[10];
	long s1, ns1;
	if( works->setup->nativeCW ) {
		gettimeofday( &tv, NULL );
		s1=tv.tv_sec;
		ns1=htonl( s1 );
		memcpy( buffer, &ns1, 4 );
		s1=tv.tv_usec;
		ns1=htonl( s1 );
		memcpy( buffer+4, &ns1, 4 );
		buffer[8]='T';
		sendWebSockCwFrame( works, buffer, 9 );
		works->setup->sidetone=1;
	} else {
		if( works->txCwLock==0 && dot == 1 ) {
			if( works->serParms->mode == 4 || works->serParms->mode == 6 ) {  
				works->cwTx( works, 1 );
			}
		}
	}
}
void gorx( workp works ) {
	struct timeval tv;
	char buffer[10];
	long s1, ns1;
	if( works->setup->nativeCW ) {
		gettimeofday( &tv, NULL );
		s1=tv.tv_sec;
		ns1=htonl( s1 );
		memcpy( buffer, &ns1, 4 );
		s1=tv.tv_usec;
		ns1=htonl( s1 );
		memcpy( buffer+4, &ns1, 4 );
		buffer[8]='R';
		sendWebSockCwFrame( works, buffer, 9 );
		works->setup->sidetone=0;
	} else {
		if( works->txCwLock==1 ) {
			works->cwTx( works, 0 );
		}
	}
}

void sendEv( workp works, char ev ) {
	struct timeval tv;
	char buffer[10];
	long s1, ns1;
	gettimeofday( &tv, NULL );
	s1=tv.tv_sec;
	ns1=htonl( s1 );
	memcpy( buffer, &ns1, 4 );
	s1=tv.tv_usec;
	ns1=htonl( s1 );
	memcpy( buffer+4, &ns1, 4 );
	buffer[8]=ev;
	sendWebSockCwFrame( works, buffer, 9 );
}

void *keyer( void *a ) {

	workp works =(workp)a;
	int DTR_flag = TIOCM_DTR;
	int flag;
	int DOT=-1;
	int DASH=-1;
	struct timeval start, stop;
	int tm;
	int tx=0;
	int oldDOT=-1;
	int oldDASH=-1;


	// continuous loop
	syslog( LOG_INFO, "Keyer thread started" );
	prctl( PR_SET_NAME, (unsigned long)"Keyer", 0, 0, 0 );

	works->keyFd = open( works->setup->KeyerDevice, O_RDWR | O_NOCTTY );
	if( works->keyFd == -1 ) {
		syslog( LOG_ERR, "unable to open keyer device %s, error %d", works->setup->KeyerDevice, errno );
	}

	for( ; works->unterminated; ) {		
		
		usleep( 1000 );
		ioctl( works->keyFd, TIOCMGET, &flag );
		DOT=(flag&TIOCM_CTS)==TIOCM_CTS?1:0;
		if( works->setup->KeyerMode==2 ) {
			DASH=(flag&TIOCM_CAR)==TIOCM_CAR?1:0;
		} else {
			DASH=0;
		}
		if( DOT || DASH ) {
			if( !tx ) {
				gotx( works, DOT );
				tx=1;
			}
			gettimeofday( &start, NULL );
		} else {
			if( works->setup->KeyerMode==1 ) {
				if( works->setup->nativeCW && oldDOT!=0 ) {
					oldDOT=0;
					sendEv( works, '-' );
				}
				works->key=0;
			}
			gettimeofday( &stop, NULL );
			tm=1000*(stop.tv_sec-start.tv_sec)+(stop.tv_usec-start.tv_usec)/1000;
			if( tm > works->setup->relax ) {
				if( tx ) {
					gorx( works );
					tx=0;
				}
			}
		}
		if( DOT ) {
			if( works->setup->nativeCW && oldDOT!=1 ) {
				oldDOT=1;
				sendEv( works, '+' );
			}
			works->key=1;
			if( works->setup->KeyerMode==2 ) {
				usleep( 1200000/works->setup->KeyerSpeed );
				works->key=0;
				if( works->setup->nativeCW ) {
					sendEv( works, '-' );
					oldDOT=0;
				}
				usleep( 1200000/works->setup->KeyerSpeed );
			}	
			gettimeofday( &start, NULL );
		}	
		if( DASH ) {
			if( works->setup->nativeCW && oldDASH!=1  ) {
				sendEv( works, '+' );
				oldDASH=1;
			}
			works->key=1;
			usleep( 3600000/works->setup->KeyerSpeed );
			if( works->setup->nativeCW ) {
				sendEv( works, '-' );
				oldDASH=0;
			}
			works->key=0;
			usleep( 1200000/works->setup->KeyerSpeed );
			gettimeofday( &start, NULL );
		}	
	}
	
	ioctl( works->keyFd, TIOCMBIC, &DTR_flag );
	close( works->keyFd );
	syslog( LOG_INFO, "Keyer operations end\n" );
	pthread_exit( a );
	return( a );
}

