/*
	Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <syslog.h>
#include <string.h>
#include <time.h>
#include <signal.h>
#include <math.h>

#include "struct.h"
   
void *oscillator( void *a ) {

	workp works =(workp)a;
	double sa=0.0, igr=0.0, gr, env=0;
	int j, k=0, tm;
	signed short val;
	char audio[192000];
	struct timeval start, stop;
	int pos;

	syslog( LOG_INFO, "Oscillator thread started" );
	prctl( PR_SET_NAME, (unsigned long)"Oscillator", 0, 0, 0 );

	memset( audio, 0, sizeof( audio ) );
	k=0;
	gettimeofday( &start, NULL );
	for( ; works->unterminated; ) {		
		if( works->setup->nativeCW ) {
			pos=works->rx_buffer_frames;
		} else {
			pos=works->tx_buffer_frames;
		}
		gr = 2.0*M_PI*works->serParms->pitch/48000.0;
		for( j=0, k=0; j<pos; j++, k+=AUDIO_BYTES_PER_SAMPLE ) {
			if( works->key ) {
				env+=(1.0-env)/works->ramp;
			} else {
				env*=1.0-1.0/works->ramp;
			}
			igr+=gr;
			if( igr > 2*M_PI ) {
				igr-=2*M_PI;
			}
			sa=sin( igr );
			val=sa*200.0*env*works->serParms->volumeSide;
			memcpy( audio+k, (char *)&val, 1 );
			memcpy( audio+k+1, ((char *)&val)+1, 1 );
			memcpy( audio+k+2, audio+k, 2);
		}
		if( works->setup->sidetone ) {
			memcpy( works->sound_buffer+works->soundWritePointer*works->rx_buffer_frames*AUDIO_BYTES_PER_SAMPLE, audio, pos*AUDIO_BYTES_PER_SAMPLE );
			works->soundWritePointer++;
			works->soundWritePointer%=(works->buffer_start*2);
     		} 
		if( works->setup->nativeCW==0 && works->txCwLock ) {
			sendWebSockAudioFrame( works, audio );
			memset( audio, 0, sizeof( audio ) );
		}
		gettimeofday( &stop, NULL );
		tm=1000000*(stop.tv_sec-start.tv_sec)+(stop.tv_usec-start.tv_usec);
		if( tm<works->setup->txChunkTime*1000 ) {
			usleep( works->setup->txChunkTime*997-tm );
		} else {
			//printf( "time %d\n", tm );
		}
		gettimeofday( &start, NULL );
	}
	
	syslog( LOG_INFO, "Oscillator thread stopped" );

	return( a );
}
