/*
        Copyright 2018-2019 Giovanni Franza - HB9EIK 

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <dlfcn.h>
#include <syslog.h>

#include "struct.h"
#include "TMATE2.h"

void tmateset( workp works ) {
	int err;
	int j, k;
	works->notmate = 0;
	for( j=0; j<9; j++ ) {
		for( k=0; k<works->tmateNbuttons; k++ ) {
			if( works->setup->t2keys[j] == works->tmateButtons[k] ) {
				works->setup->t2keysidx[j]=k;
				break;
			}
		}
	}	
	for( j=9; j<12; j++ ) {
		for( k=0; k<works->tmateNencoders; k++ ) {
			if( works->setup->t2keys[j] == works->tmateEncoders[k] ) {
				works->setup->t2keysidx[j]=k;
				break;
			}
		}
	}	
	if( works->tmatehandle == NULL ) {
		works->tmatehandle = dlopen( "./libTMATE2.so",  RTLD_LAZY );
	}
	if( !works->tmatehandle ) {
		syslog( LOG_INFO, "libTmate not found" );
		works->notmate = 1;
	} else {
		works->TMate2OpenConnection = dlsym( works->tmatehandle, "TMate2OpenConnection" );
		if( !dlerror() )  {
			err = works->TMate2OpenConnection( );
			if( err == -1 ) {
				syslog( LOG_INFO, "Tmate device not found" );
				works->notmate = 1;
			} else {
				sleep( 1 );
				dlerror();
				works->TMate2CloseConnection = dlsym( works->tmatehandle, "TMate2CloseConnection" );
				if( dlerror() )  {
					syslog( LOG_INFO, "TMate2CloseConnection not found" );
					works->notmate = 1;
				} else {
					dlerror();
					works->TMate2SetStatus = dlsym( works->tmatehandle, "TMate2SetStatus" );
					if( dlerror() )  {
						syslog( LOG_INFO, "TMate2SetStatus not found" );
						works->notmate = 1;
					} else {
						dlerror();
						works->TMate2AddCallback = dlsym( works->tmatehandle, "TMate2AddCallback" );
						if( dlerror() )  {
							syslog( LOG_INFO, "TMate2AddCallback not found" );
							works->notmate = 1;
						} else {
							dlerror();
							works->TMate2ReadVersion = dlsym( works->tmatehandle, "TMate2ReadVersion" );
							if( dlerror() )  {
								syslog( LOG_INFO, "TMate2ReadVersion not found" );
								works->notmate = 1;
							}
						}
					}
				}
			}
		}
	}
	if( works->notmate  ) {
		if( works->tmatehandle  ) {
			if( works->TMate2CloseConnection ) {
				works->TMate2CloseConnection();
			}
		}
		works->TMate2OpenConnection = NULL;
		works->TMate2CloseConnection = NULL;
		works->TMate2SetStatus = NULL;
		works->TMate2AddCallback = NULL;
		works->TMate2ReadVersion = NULL;
	} else {
		for( j=0; j<12; j++ ) {
			works->tmateaddcallback( (void *)works, j );
		}	
	}
}

void tmateaddcallback( void *works, int num ) {
	int k;
	if( ((workp)works)->notmate ) {
		return;
	}
	if( !((workp)works)->TMate2AddCallback ) {
		return;
	}
	k=((workp)works)->setup->t2keys[num]-1;
	if( (((workp)works)->buttons+k)->isEncoder ) {
		((workp)works)->TMate2AddCallback( num,  k, NULL, (void*)works, NULL, NULL, (((workp)works)->buttons+k)->wheelDn, (((workp)works)->buttons+k)->wheelUp );
	} else {
		if( (((workp)works)->buttons+k)->down == NULL ) {
			if( (((workp)works)->buttons+k)->up == NULL ) {
				if( (((workp)works)->buttons+k)->tmate==1 ) {
					((workp)works)->TMate2AddCallback( num, 1, NULL, (void*)works, NULL, NULL, (((workp)works)->buttons+k)->write, NULL );
				} else if( (((workp)works)->buttons+k)->tmate==2 ) {
					((workp)works)->TMate2AddCallback( num, 1, NULL, (void*)works, NULL, NULL, (((workp)works)->buttons+k)->dxdn, NULL );
				} else {
					((workp)works)->TMate2AddCallback( num, (((workp)works)->buttons+k)->tmate-2, NULL, (void*)works, NULL, NULL, (((workp)works)->buttons+k)->write, NULL );
				}
			} else {
				if( (((workp)works)->buttons+k)->tmate==1 ) {
					((workp)works)->TMate2AddCallback( num, -1, NULL, (void*)works, NULL, NULL, (((workp)works)->buttons+k)->write, (((workp)works)->buttons+k)->write );
				} else {
					((workp)works)->TMate2AddCallback( num, -1, NULL, (void*)works, NULL, NULL, (((workp)works)->buttons+k)->write, NULL );
				}
			}
		} else {
			((workp)works)->TMate2AddCallback( num, k, &((((workp)works)->buttons+k)->activated), (void*)works, ((workp)works)->auxdown, (((workp)works)->buttons+k)->write, (((workp)works)->buttons+k)->down, (((workp)works)->buttons+k)->up );
		}
	}
}
void controltmate ( workp works ) {
	char H1, H2, F1, F2;
	int rc;
	rc=0;
	if( works->TMate2ReadVersion ) {
		if( works->TMate2ReadVersion( &H1, &H2, &F1, &F2 ) == -1 ) {
			rc=1;
		} 
	} else {
		rc=1;
	}
	if( rc ) {
		works->notmate=1;
		tmateset( works );
	}
}

